/* CRT EMULATIONS */

#include "myrt.h"

VOID ZeroMemory(PVOID p, DWORD size)
{
	DWORD i;

	if(!p)
		return;

	for(i = 0; i < size; i++)
		*((char*)p)++ = 0;

	return;
}

VOID strcopy(LPSTR dst, LPCSTR src)
{
	while(*src)
		*dst++ = *src++;
	*dst = *src;	// copy null

	return;
}

DWORD strlength(LPCSTR src)
{
	DWORD result = 0;

	while(*src++)
		result++;

	return result;
}

// Ƃ肱: CRTgȂstrcmp
//  Win32APIStrCmpW͂邯ǂˁB
int strcomp(const char* p, const char *q)
{
	if(!p || !q)
		return 0;	// ǂ悤˂
	if(p == q)
		return 0;	// |C^Ȃ瓯B

	while(*p == *q && *p != '\0')	// *p*qNULLɂȂΎ(Ⴄ)BłȂƂp0Ȃ玀(񓯂)B
	{	// *p++ == *q++ && *p != '\0'ƂǁA*p != '\0']Op++ĂB
		p++;
		q++;
	}

	return *p - *q;	// WikipediaɂBꂷ...ł-1`1͈̔͂ȂȂB
	/*
	if(*p < *q)
		return -1;
	if(*p > *q)
		return 1;

	return 0;
	*/
}

HWND CreateWindowCX(DWORD dwExStyle, LPCTSTR lpClassName, LPCTSTR lpWindowName, DWORD dwStyle, int X, int Y, int nWidth, int nHeight, HWND hWndParent, HMENU hMenu, HINSTANCE hInstance, LPVOID lpParam)
{
	RECT rc;

	rc.left = X;
	rc.top = Y;
	rc.right = X + nWidth;
	rc.bottom = Y + nHeight;

	AdjustWindowRectEx(&rc, dwStyle, hMenu ? TRUE : FALSE, dwExStyle);

	return CreateWindowEx(dwExStyle, lpClassName, lpWindowName, dwStyle, rc.left, rc.top, rc.right - rc.left, rc.bottom - rc.top, hWndParent, hMenu, hInstance, lpParam);
}

// ƂՂ炷: CRTgȂstrcat
void strplus(char* p, const char *c)
{
	if(!p || !c || p == c)
		return;

	p += strlength(p);	// NULLO܂Ő
	strcopy(p, c);		// strcopyB

	return;
}

void* halloc(DWORD size)
{
	return HeapAlloc(GetProcessHeap(), 0, size);
}

void hfree(void* ptr)
{
	if(ptr)
		HeapFree(GetProcessHeap(), 0, ptr);

	return;
}

VOID strncopy(LPSTR dst, LPCSTR src, DWORD size)
{
	while(*src && size--)
		*dst++ = *src++;

	return;
}

void* hrealloc(void* ptr, DWORD size)
{
	return HeapReAlloc(GetProcessHeap(), 0, ptr, size);
}

// t@CԂB^ꂽ̒̃|C^B
char* lastname(const char* str, char delimiter)
{
	char* last = (char*)str;

	while(*str)
	{
		// ANSIȂB
		if(!IsDBCSLeadByte(*str) && *str == delimiter)
			last = (char*)str + 1;
		str = CharNext(str);
	}

	return last;
}

char* basename(const char* str)
{
	return lastname(str, '\\');
}

char* strchar(const char* str, char tofind)
{
	char* p = (char*)str;

	while(*p)
	{
		// ANSIȂB
		if(!IsDBCSLeadByte(*p) && *p == tofind)
			break;
		p = CharNext(p);
	}

	return p;
}

int strncomp(const char* p, const char *q, int len)
{
	if(!p || !q)
		return 0;	// ǂ悤˂
	if(p == q)
		return 0;	// |C^Ȃ瓯B

	while(len-- && *p == *q && *p != '\0')	// *p*qNULLɂȂΎ(Ⴄ)BłȂƂp0Ȃ玀(񓯂)B
	{	// *p++ == *q++ && *p != '\0'ƂǁA*p != '\0']Op++ĂB
		p++;
		q++;
	}

	if(len == -1)	// len--0̎Ă-1ɂȂĂB
	{
		p--;
		q--;
	}

	return *p - *q;	// WikipediaɂBꂷ...ł-1`1͈̔͂ȂȂB
	/*
	if(*p < *q)
		return -1;
	if(*p > *q)
		return 1;

	return 0;
	*/
}

char* strclone(const char* str)
{
	char* newbuf;

	if(!(newbuf = halloc(strlength(str) + 1)))
		return NULL;

	strcopy(newbuf, str);

	return newbuf;
}
